// SPDX-License-Identifier: Apache-2.0
import { createMock } from "@golevelup/ts-jest";
import { ErrorMsgFixture, EvmAddressPropsFixture } from "../../../../../../../__tests__/fixtures/shared/DataFixture";
import { ErrorCode } from "../../../../../../core/error/BaseError";
import EvmAddress from "../../../../../../domain/context/contract/EvmAddress";
import { GetRolesForQueryFixture } from "../../../../../../../__tests__/fixtures/role/RoleFixture";
import { GetRolesForQueryResponse } from "./GetRolesForQuery";
import { GetRolesForQueryHandler } from "./GetRolesForQueryHandler";
import { GetRolesForQueryError } from "./error/GetRolesForQueryError";
describe("GetRolesForQueryHandler", () => {
    let handler;
    let query;
    const queryAdapterServiceMock = createMock();
    const contractServiceMock = createMock();
    const accountServiceMock = createMock();
    const evmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const role = "role";
    const targetEvmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const errorMsg = ErrorMsgFixture.create().msg;
    beforeEach(() => {
        handler = new GetRolesForQueryHandler(queryAdapterServiceMock, accountServiceMock, contractServiceMock);
        query = GetRolesForQueryFixture.create();
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    describe("execute", () => {
        it("throws GetRolesForQueryError when query fails with uncaught error", async () => {
            const fakeError = new Error(errorMsg);
            contractServiceMock.getContractEvmAddress.mockRejectedValue(fakeError);
            const resultPromise = handler.execute(query);
            await expect(resultPromise).rejects.toBeInstanceOf(GetRolesForQueryError);
            await expect(resultPromise).rejects.toMatchObject({
                message: expect.stringContaining(`An error occurred while querying account roles: ${errorMsg}`),
                errorCode: ErrorCode.UncaughtQueryError,
            });
        });
        it("should successfully get roles for", async () => {
            contractServiceMock.getContractEvmAddress.mockResolvedValueOnce(evmAddress);
            accountServiceMock.getAccountEvmAddress.mockResolvedValueOnce(targetEvmAddress);
            queryAdapterServiceMock.getRolesFor.mockResolvedValueOnce([role]);
            const result = await handler.execute(query);
            expect(result).toBeInstanceOf(GetRolesForQueryResponse);
            expect(result.payload).toStrictEqual([role]);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledTimes(1);
            expect(accountServiceMock.getAccountEvmAddress).toHaveBeenCalledTimes(1);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledWith(query.securityId);
            expect(accountServiceMock.getAccountEvmAddress).toHaveBeenCalledWith(query.targetId);
            expect(queryAdapterServiceMock.getRolesFor).toHaveBeenCalledWith(evmAddress, targetEvmAddress, query.start, query.end);
        });
    });
});
